const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const standards = sequelize.define(
    'standards',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

short_name: {
        type: DataTypes.TEXT,
      
      

      },

version: {
        type: DataTypes.TEXT,
      
      

      },

publisher: {
        type: DataTypes.TEXT,
      
      

      },

scope_notes: {
        type: DataTypes.TEXT,
      
      

      },

active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  standards.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity







    db.standards.hasMany(db.clauses, {
      as: 'clauses_standard',
      foreignKey: {
          name: 'standardId',
      },
      constraints: false,
    });




























//end loop






    db.standards.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.standards.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return standards;
};


